/*! phoscon-app 2020-02-14 */

import{initDevicesSwitchView}from"./devices-switches/devices-switches-view.js";import{injectSwitchWizzardSvg}from"./devices-switches/load-svg.js";import{initMachine}from"./devices-switches/devices-switches-machine.js";import{createMachineContent}from"./devices-switches/make-machine.js";import{initPages}from"./devices-switches/map.js";import{getPageContent,translatePage}from"./devices-switches/load-page.js";import{getScanStates}from"./devices-switches/scan-states.js";import{START_SCAN,STOP_SCAN,DEVICE_ADDED,DEVICE_UPDATED,DEVICE_NO_UPDATED,NO_DEVICE_ADDED}from"./devices-switches/scan-states.js";import{addClassToAll,removeClassToAll,callFunc}from"./devices-switches/generic-helper-functions.js";import{actions as pageActions}from"./devices-switches/machine-actions.js";import{initOverview}from"./devices-switches/overview-view.js";import{initDetailsView}from"./devices-switches/details-view.js";import*as c from"./devices-switches/constants.js";import*as scanActions from"./devices-switches/scan-actions.js";import*as scanFunctions from"./devices-switches/scan-functions.js";const{Machine:Machine,actions:actions,State:State}=XState,{interpret:interpret}=XStateInterpreter,{send:send,sendParent:sendParent,log:log,raise:raise,assign:assign}=actions;async function initViewAndLogic(){var overviewInitial=0!==app.switches.models.length?"table":"empty";const pageParams={},generalViews=initOverview(),detailsView=initDetailsView(injectSwitchWizzardSvg);generalViews.detailsView=detailsView;const pages=initPages(pageParams),view=await initDevicesSwitchView(addClassToAll,removeClassToAll,injectSwitchWizzardSvg),states=await createMachineContent(pages,c),scanStates=await getScanStates(scanActions),functions=await getMachineFunctions(scanFunctions,getPageContent,translatePage),actions=await getPageActions(pageActions);let context={overviewInitial:overviewInitial,...functions,callFunc:callFunc,view:view,generalViews:generalViews,constants:{...c,START_SCAN:START_SCAN,STOP_SCAN:STOP_SCAN,DEVICE_ADDED:DEVICE_ADDED,DEVICE_UPDATED:DEVICE_UPDATED,DEVICE_NO_UPDATED:DEVICE_NO_UPDATED,NO_DEVICE_ADDED:NO_DEVICE_ADDED},pageParams:pageParams,noteSw:{}},pagesStates={id:"pages",initial:"page-init",states:states};const machine=await initMachine(pagesStates,scanStates,actions,Machine,interpret,context);app.machine=machine;var service=machine.context.service;view.service=service,generalViews.tableView.views.forEach(view=>{view.service=service},this),app.navItem=document.querySelector("#dSwitch2").parentElement,app.navItem.addEventListener("click",function(){app.router.navigate("table",{trigger:!0})}),app.headLeftBtn=document.querySelector(".header #menu-btn"),app.headLeftSvg=app.headLeftBtn.querySelector("use"),app.headLeftLabel=app.headLeftBtn.querySelector("span");var Router=Backbone.Router.extend({routes:{"wizard/:page":"showSwitchWizard","switch/:id":"showSwitchDetails",table:"showSwitchTable"},showSwitchDetails:function(id){app.navItem.classList.add("sub-item");let sw=app.switches.get(id);sw&&service.send({type:"DETAILS",model:sw}),(screenMax(SCREEN_MAX_WIDTH_PHONE_PORTRAIT)||screen.height<420)&&(app.headLeftSvg.setAttribute("xlink:href","#back-icon-sm"),app.headLeftLabel.textContent=translate("link_switches"))},showSwitchTable:function(url){app.session.swid=void 0,app.headLeftSvg.setAttribute("xlink:href","#icon-hamburger-sm"),app.headLeftLabel.textContent="",app.navItem.classList.remove("sub-item"),service.send("TABLE")},showSwitchWizard:function(page){console.log("%c showSwitchWizard: "+page,INFO),service.send(page)}});app.router=new Router,Backbone.history.start();let backboneHistoryFragment=Backbone.history.getFragment();if(-1!==backboneHistoryFragment.indexOf("wizard")){if("PAGE_VENDOR"!==backboneHistoryFragment){$("#switchWizardModal").modal("show");let route="wizard/PAGE_VENDOR";app.router.navigate(route,{trigger:!0})}if(-1!==backboneHistoryFragment.indexOf("PRODUCT")){let route=backboneHistoryFragment;app.router.navigate(route,{trigger:!0})}}app.headLeftBtn.onclick=void 0,app.headLeftBtn.addEventListener("click",function(){(screenMax(SCREEN_MAX_WIDTH_PHONE_PORTRAIT)||screen.height<420)&&document.location.hash.indexOf("switch/")>0?app.router.navigate("table",{trigger:!0}):openNav()}),app.switches.on("add",function(sw){machine.context.noteSw.id=sw.id,app.session.swid=sw.id,machine.context.service.send({type:DEVICE_ADDED,device:sw})},this),app.api.on("switch-added",function(sw){machine.context.noteSw.id=sw.id,app.session.swid=sw.id,machine.context.service.send({type:DEVICE_ADDED,device:sw})},this),app.switches.on("change",function(sw){sw&&sw.attributes&&(machine.context.noteSw.id=sw.id,app.session.swid=sw.id,service.send({type:DEVICE_UPDATED,device:sw}))},this),document.querySelectorAll("[data-modal]").forEach(elem=>{elem.addEventListener("click",function(e){let el=e.currentTarget;if(!el)return;let ev=el.getAttribute("data-btn-ev");service.send(ev)})}),loadLanguage(),$(document).on("show.bs.modal","#deleteSwitchModal",function(){var sw=app.switches.get(app.session.swid),name=sw.get("name");this.querySelector(".modal-body span b").innerText=name,this.querySelector(".modal-footer .btn-primary").addEventListener("click",function(){deleteSwitch(sw,service)})}),document.querySelectorAll(".dev-scroll-cont").forEach(el=>{el.onscroll=function(){setShadowClass(this)}})}function getMachineFunctions(s,getPageContent,translatePage){return{enableSensorSearch:s.enableSensorSearch,disableSensorSearch:s.disableSensorSearch,blinkAllLights:s.blinkAllLights,renameSwitch:s.renameSwitch,getPageContent:getPageContent,translatePage:translatePage,routeToDetails:routeToDetails,setShadowClass:setShadowClass}}function getPageActions(actions){return{...actions,[c.CALL_FUNC]:callFunc}}function deleteSwitch(sw,service){sw&&(sw.destroy(),app.router.navigate("table",{trigger:!0}))}function routeToDetails(ctx,event){ctx.noteSw&&ctx.noteSw.id&&(app.router.navigate("switch/"+ctx.noteSw.id,{trigger:!0}),ctx.noteSw.id=void 0)}function setShadowClass(el){el.classList[el.scrollTop>10?"add":"remove"]("shadow-top"),el.classList[el.scrollHeight-el.clientHeight-el.scrollTop>10?"add":"remove"]("shadow-bottom")}initApp(),restGetResource(app.config).then(()=>restGetResource(app.sensors)).then(res=>{setTimeout(()=>app.poll.pollRepeated(app.config),5e3),setTimeout(()=>app.poll.pollRepeated(app.sensors),5e3),app.sensorScan.fetch(),initViewAndLogic()});var date=function(){var d=new Date("2011-04-20T09:30:51.01");return d.getHours()+":"+d.getMinutes()+":"+d.getSeconds()+":"+d.getMilliseconds()};